Summary: Panic for PCL; a component of FEFPCL tool.
Name: FJSVpanicforpcl
Version: 1.0.0
Release: 2%{?dist}
License: GPLv2
Group: System Environment/Base
Source0: %{name}-%{version}.tar.gz
Packager: FUJITSU LIMITED
Vendor: FUJITSU LIMITED
URL: http://www.fujitsu.com/
ExclusiveOS: Linux
ExclusiveArch: x86_64
Buildroot: %{_tmppath}/%{name}-root
BuildRequires: kernel-devel, gcc, bash
Requires: dracut systemd kmod-%{name} FJSVkdump-post-wrapper ipmitool
%systemd_requires
Requires(posttrans): systemd

%define kdump_config_file /etc/kdump.conf

%description
A component of FEFPCL tool.

%kernel_module_package

%prep
%setup -n %{name}-%{version}

set -- *
mkdir source
mv "$@" source/
mkdir obj

%post
%systemd_post FJSVpanicforpcl.service

%preun
%systemd_preun FJSVpanicforpcl.service

%postun
if [ $1 -eq 0 ] ; then
  touch %kdump_config_file >/dev/null 2>&1 || :
fi

%posttrans
touch %kdump_config_file >/dev/null 2>&1 || :

%build
cd source/panicforpcl
make CDIR=%{kernel_source default} MDIR=$PWD
cd ../../

%install
cd source/panicforpcl
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{name}
make CDIR=%{kernel_source default} MDIR=$PWD install
# Cleanup unnecessary kernel-generated module dependency files.
find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
# Sign kernel module files for Secure Boot Support
find $INSTALL_MOD_PATH/lib/modules -name '*.ko' -exec \
    /usr/src/kernels/%{kverrel}/scripts/sign-file sha256 \
    /usr/src/kernels/keys/priv/private_key.priv \
    /usr/src/kernels/keys/public_key.der {} \;
find $INSTALL_MOD_PATH/lib/modules -name '*.ko' -exec modinfo {} \;
cd ../../

%define src_moddir source/for-panicforpcl-files/dracut/modules.d/99panicforpcl
%define src_confdir source/for-panicforpcl-files/dracut/dracut.conf.d
%define dest_moddir %{buildroot}/usr/lib/dracut/modules.d/99panicforpcl
%define dest_confdir %{buildroot}/usr/lib/dracut/dracut.conf.d

install -m 755 -d %{dest_moddir}
install -m 755 %{src_moddir}/module-setup.sh %{dest_moddir}/module-setup.sh
install -m 755 %{src_moddir}/set_system_status_dumping.sh %{dest_moddir}/set_system_status_dumping.sh
install -m 755 %{src_moddir}/00-set_system_status_halt.sh %{dest_moddir}/00-set_system_status_halt.sh
install -m 644 %{src_moddir}/panicforpcl.conf %{dest_moddir}/panicforpcl.conf
install -m 644 %{src_moddir}/panicforpcl_lib.sh %{dest_moddir}/panicforpcl_lib.sh
install -m 755 -d %{dest_confdir}
install -m 644 %{src_confdir}/99-panicforpcl.conf %{dest_confdir}/99-panicforpcl.conf
install -m 755 -d %{buildroot}/etc/logrotate.d
install -m 644 source/for-panicforpcl-files/logrotate.d.FJSVpanicforpcl %{buildroot}/etc/logrotate.d/FJSVpanicforpcl
install -m 755 -d %{buildroot}%{_unitdir}
install -m 644 source/for-panicforpcl-files/systemd/system/FJSVpanicforpcl.service %{buildroot}%{_unitdir}/FJSVpanicforpcl.service
install -m 755 -d %{buildroot}%{_presetdir}
install -m 644 source/for-panicforpcl-files/systemd/system-preset/98-panicforpcl.preset %{buildroot}%{_presetdir}/98-panicforpcl.preset
install -m 755 -d %{buildroot}%{_bindir}
install -m 755 source/panicforpcl/panicforpcl.sh %{buildroot}/usr/bin/panicforpcl

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
/usr/lib/dracut/modules.d
/usr/lib/dracut/modules.d/99panicforpcl
/usr/lib/dracut/modules.d/99panicforpcl/module-setup.sh
/usr/lib/dracut/modules.d/99panicforpcl/set_system_status_dumping.sh
/usr/lib/dracut/modules.d/99panicforpcl/00-set_system_status_halt.sh
/usr/lib/dracut/modules.d/99panicforpcl/panicforpcl_lib.sh
/usr/lib/dracut/dracut.conf.d
/usr/lib/dracut/dracut.conf.d/99-panicforpcl.conf
/etc/logrotate.d/FJSVpanicforpcl
/usr/lib/systemd/system/FJSVpanicforpcl.service
/usr/lib/systemd/system-preset/98-panicforpcl.preset
/usr/bin/panicforpcl
/usr/lib/dracut/modules.d/99panicforpcl/panicforpcl.conf

%changelog
* Wed May 25 2018 FUJITSU LIMITED (1.0.0-2)
- Retpoline support for speculative execution branch target injection (CVE-2017-5715). (BS01646)
* Wed Jul 8 2015 FUJITSU LIMITED (1.0.0-1)
- Secure Boot Support (BS01597)
* Thu Feb 13 2014 FUJITSU LIMITED
- FJSVpanicforpcl was newly packaged. (BS01570)
