#! /bin/sh

IPMITOOL="/usr/bin/ipmitool"

TARGET_ADDRESS="0x20"
IPMB_ADDRESS="0x02"
IPMI_NETFN_APP="0x06"
CMD_SEND_MESSAGE="0x34"

DATA_POWER_OFF="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x00 0x03 0x40 0x0f 0xff 0x42"
DATA_POWER_ON_IN_PROGRESS="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x01 0x03 0x41 0x0f 0xff 0x40"
DATA_RESET="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x02 0x03 0x42 0x0f 0xff 0x3e"
DATA_POST="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x03 0x03 0x43 0x0f 0xff 0x3c"
DATA_BOOT="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x04 0x03 0x44 0x0f 0xff 0x3a"
DATA_OS_RUNNING="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x05 0x03 0x45 0x0f 0xff 0x38"
DATA_OS_SHUTDOWN="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x06 0x03 0x46 0x0f 0xff 0x36"
DATA_PANIC="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x07 0x03 0x47 0x0f 0xff 0x34"
DATA_POWER_OFF_IN_PROGRESS="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x08 0x03 0x48 0x0f 0xff 0x32"
DATA_FATAL="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x09 0x03 0x49 0x0f 0xff 0x30"
DATA_DUMPING="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x0a 0x03 0x4a 0x0f 0xff 0x2e"
DATA_HALT="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x0b 0x03 0x4b 0x0f 0xff 0x2c"
DATA_STOP_ERROR="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x0c 0x03 0x4c 0x0f 0xff 0x2a"
DATA_XPAR_FIRMWARE_RUNNING="0x00 0x24 0xc0 0x1c 0x20 0x02 0x4b 0x0c 0x03 0x4c 0x0f 0xff 0x2a"

send_POWER_OFF() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_POWER_OFF
}

send_POWER_ON_IN_PROGRESS() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_POWER_ON_IN_PROGRESS
}

send_RESET() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_RESET
}

send_POST() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_POST
}

send_BOOT() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_BOOT
}

send_OS_RUNNING() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_OS_RUNNING
}

send_OS_SHUTDOWN() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_OS_SHUTDOWN
}

send_PANIC() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_PANIC
}

send_POWER_OFF_IN_PROGRESS() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_POWER_OFF_IN_PROGRESS
}

send_FATAL() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_FATAL
}

send_DUMPING() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_DUMPING
}

send_HALT() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_HALT
}

send_STOP_ERROR() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_STOP_ERROR
}

send_XPAR_FIRMWARE_RUNNING() {
    $IPMITOOL -t $TARGET_ADDRESS -m $IPMB_ADDRESS raw $IPMI_NETFN_APP $CMD_SEND_MESSAGE $DATA_XPAR_FIRMWARE_RUNNING
}
